]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
revert: do not pass non-literal string as format to git_path()
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
9db31bdf 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
31ca3ac3 29nofetch=
32948425 30update=
15fc56a8 31prefix=
70c7ac22 32
f31a522a
ML
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
98fcf840 36 remote=$(get_default_remote)
8e7e6f39 37 remoteurl=$(git config "remote.$remote.url") ||
4d689320 38 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 39 url="$1"
99b120af 40 remoteurl=${remoteurl%/}
ea640cc6 41 sep=/
f31a522a
ML
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
ea640cc6
TR
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
497ee872 56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
ea640cc6
TR
57 ;;
58 esac
f31a522a
ML
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
ea640cc6 67 echo "$remoteurl$sep${url%/}"
f31a522a
ML
68}
69
a7b3269c
DA
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
313ee0d6
NMC
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
a7b3269c
DA
94}
95
941987a5
LH
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
537601ac 103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
fe22e542 104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a
TRC
107 test -z "$name" &&
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
109 echo "$name"
941987a5 110}
33aa6fff
LH
111
112#
113# Clone a submodule
114#
23a485e3 115# Prior to calling, cmd_update checks that a possibly existing
ecda0723 116# path is not a git repository.
23a485e3 117# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
118# since it is the location of a new submodule.
119#
33aa6fff
LH
120module_clone()
121{
122 path=$1
123 url=$2
d92a3959 124 reference="$3"
7e60407f
JL
125 quiet=
126 if test -n "$GIT_QUIET"
127 then
128 quiet=-q
129 fi
33aa6fff 130
501770e1
FG
131 gitdir=
132 gitdir_base=
9e76d4a8 133 name=$(module_name "$path" 2>/dev/null)
501770e1 134 base_path=$(dirname "$path")
33aa6fff 135
501770e1
FG
136 gitdir=$(git rev-parse --git-dir)
137 gitdir_base="$gitdir/modules/$base_path"
138 gitdir="$gitdir/modules/$path"
139
140 case $gitdir in
141 /*)
142 a="$(cd_to_toplevel && pwd)/"
143 b=$gitdir
144 while [ "$b" ] && [ "${a%%/*}" = "${b%%/*}" ]
145 do
146 a=${a#*/} b=${b#*/};
147 done
148
149 rel="$a$name"
150 rel=`echo $rel | sed -e 's|[^/]*|..|g'`
151 rel_gitdir="$rel/$b"
152 ;;
153 *)
154 rel=`echo $name | sed -e 's|[^/]*|..|g'`
155 rel_gitdir="$rel/$gitdir"
156 ;;
157 esac
158
159 if test -d "$gitdir"
d92a3959 160 then
501770e1
FG
161 mkdir -p "$path"
162 echo "gitdir: $rel_gitdir" >"$path/.git"
163 rm -f "$gitdir/index"
d92a3959 164 else
501770e1
FG
165 mkdir -p "$gitdir_base"
166 if test -n "$reference"
167 then
efc5fb6a 168 git-clone $quiet "$reference" -n "$url" "$path" --separate-git-dir "$gitdir"
501770e1 169 else
efc5fb6a 170 git-clone $quiet -n "$url" "$path" --separate-git-dir "$gitdir"
501770e1
FG
171 fi ||
172 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
173 fi
33aa6fff
LH
174}
175
ecda0723
SV
176#
177# Add a new submodule to the working tree, .gitmodules and the index
178#
ec05df35 179# $@ = repo path
ecda0723
SV
180#
181# optional branch is stored in global branch variable
182#
23a485e3 183cmd_add()
ecda0723 184{
5c08dbbd
JH
185 # parse $args after "submodule ... add".
186 while test $# -ne 0
187 do
188 case "$1" in
189 -b | --branch)
190 case "$2" in '') usage ;; esac
191 branch=$2
192 shift
193 ;;
d27b876b
JL
194 -f | --force)
195 force=$1
196 ;;
5c08dbbd 197 -q|--quiet)
2e6a30ef 198 GIT_QUIET=1
5c08dbbd 199 ;;
d92a3959
MT
200 --reference)
201 case "$2" in '') usage ;; esac
202 reference="--reference=$2"
203 shift
204 ;;
205 --reference=*)
206 reference="$1"
207 shift
208 ;;
5c08dbbd
JH
209 --)
210 shift
211 break
212 ;;
213 -*)
214 usage
215 ;;
216 *)
217 break
218 ;;
219 esac
220 shift
221 done
222
ecda0723
SV
223 repo=$1
224 path=$2
225
1414e578
JL
226 if test -z "$path"; then
227 path=$(echo "$repo" |
228 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
229 fi
230
ec05df35 231 if test -z "$repo" -o -z "$path"; then
ecda0723
SV
232 usage
233 fi
234
ec05df35
ML
235 # assure repo is absolute or relative to parent
236 case "$repo" in
237 ./*|../*)
238 # dereference source url relative to parent's url
239 realrepo=$(resolve_relative_url "$repo") || exit
240 ;;
241 *:*|/*)
242 # absolute url
243 realrepo=$repo
244 ;;
245 *)
497ee872 246 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
247 ;;
248 esac
249
db75ada5
MG
250 # normalize path:
251 # multiple //; leading ./; /./; /../; trailing /
252 path=$(printf '%s/\n' "$path" |
253 sed -e '
254 s|//*|/|g
255 s|^\(\./\)*||
256 s|/\./|/|g
257 :start
258 s|\([^/]*\)/\.\./||
259 tstart
260 s|/*$||
261 ')
5be60078 262 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
497ee872 263 die "$(eval_gettext "'\$path' already exists in the index")"
ecda0723 264
d27b876b
JL
265 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
266 then
6ff875c5 267 eval_gettextln "The following path is ignored by one of your .gitignore files:
3a4c3ed7 268\$path
6ff875c5 269Use -f if you really want to add it." >&2
d27b876b
JL
270 exit 1
271 fi
272
d4264ca3
ML
273 # perhaps the path exists and is already a git repo, else clone it
274 if test -e "$path"
275 then
e9656473 276 if test -d "$path"/.git -o -f "$path"/.git
d4264ca3 277 then
6ff875c5 278 eval_gettextln "Adding existing repo at '\$path' to the index"
d4264ca3 279 else
497ee872 280 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
d4264ca3 281 fi
c2f93917 282
d4264ca3 283 else
d4264ca3 284
d92a3959 285 module_clone "$path" "$realrepo" "$reference" || exit
ea10b60c 286 (
74ae1419 287 clear_local_git_env
ea10b60c
BJ
288 cd "$path" &&
289 # ash fails to wordsplit ${branch:+-b "$branch"...}
290 case "$branch" in
291 '') git checkout -f -q ;;
502dc5b6 292 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 293 esac
497ee872 294 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
d4264ca3 295 fi
c56dce3b 296 git config submodule."$path".url "$realrepo"
d4264ca3 297
d27b876b 298 git add $force "$path" ||
497ee872 299 die "$(eval_gettext "Failed to add submodule '\$path'")"
ecda0723 300
a5099bb4
IY
301 git config -f .gitmodules submodule."$path".path "$path" &&
302 git config -f .gitmodules submodule."$path".url "$repo" &&
31991b02 303 git add --force .gitmodules ||
497ee872 304 die "$(eval_gettext "Failed to register submodule '\$path'")"
ecda0723
SV
305}
306
19a31f9c
ML
307#
308# Execute an arbitrary command sequence in each checked out
309# submodule
310#
311# $@ = command to execute
312#
313cmd_foreach()
314{
1d5bec8b
JH
315 # parse $args after "submodule ... foreach".
316 while test $# -ne 0
317 do
318 case "$1" in
319 -q|--quiet)
320 GIT_QUIET=1
321 ;;
15fc56a8
JH
322 --recursive)
323 recursive=1
324 ;;
1d5bec8b
JH
325 -*)
326 usage
327 ;;
328 *)
329 break
330 ;;
331 esac
332 shift
333 done
334
f030c96d
ÆAB
335 toplevel=$(pwd)
336
4dca1aa6
BC
337 # dup stdin so that it can be restored when running the external
338 # command in the subshell (and a recursive call to this function)
339 exec 3<&0
340
a7b3269c 341 module_list |
19a31f9c
ML
342 while read mode sha1 stage path
343 do
344 if test -e "$path"/.git
345 then
490b6d57 346 say "$(eval_gettext "Entering '\$prefix\$path'")"
1e7f2aad 347 name=$(module_name "$path")
15fc56a8
JH
348 (
349 prefix="$prefix$path/"
74ae1419 350 clear_local_git_env
15fc56a8
JH
351 cd "$path" &&
352 eval "$@" &&
353 if test -n "$recursive"
354 then
355 cmd_foreach "--recursive" "$@"
356 fi
4dca1aa6 357 ) <&3 3<&- ||
497ee872 358 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
19a31f9c
ML
359 fi
360 done
361}
362
70c7ac22 363#
211b7f19 364# Register submodules in .git/config
70c7ac22
LH
365#
366# $@ = requested paths (default to all)
367#
23a485e3 368cmd_init()
70c7ac22 369{
5c08dbbd
JH
370 # parse $args after "submodule ... init".
371 while test $# -ne 0
372 do
373 case "$1" in
374 -q|--quiet)
2e6a30ef 375 GIT_QUIET=1
5c08dbbd
JH
376 ;;
377 --)
378 shift
379 break
380 ;;
381 -*)
382 usage
383 ;;
384 *)
385 break
386 ;;
387 esac
388 shift
389 done
390
a7b3269c 391 module_list "$@" |
70c7ac22
LH
392 while read mode sha1 stage path
393 do
211b7f19 394 # Skip already registered paths
941987a5 395 name=$(module_name "$path") || exit
2cd9de3e
JL
396 if test -z "$(git config "submodule.$name.url")"
397 then
398 url=$(git config -f .gitmodules submodule."$name".url)
399 test -z "$url" &&
0591c0a5 400 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
2cd9de3e
JL
401
402 # Possibly a url relative to parent
403 case "$url" in
404 ./*|../*)
405 url=$(resolve_relative_url "$url") || exit
406 ;;
407 esac
408 git config submodule."$name".url "$url" ||
0591c0a5 409 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
2cd9de3e 410 fi
70c7ac22 411
2cd9de3e 412 # Copy "update" setting when it is not set yet
32948425
JH
413 upd="$(git config -f .gitmodules submodule."$name".update)"
414 test -z "$upd" ||
2cd9de3e 415 test -n "$(git config submodule."$name".update)" ||
32948425 416 git config submodule."$name".update "$upd" ||
497ee872 417 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
ca2cedba 418
497ee872 419 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
70c7ac22
LH
420 done
421}
422
423#
211b7f19 424# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
425#
426# $@ = requested paths (default to all)
427#
23a485e3 428cmd_update()
70c7ac22 429{
5c08dbbd 430 # parse $args after "submodule ... update".
98dbe63d 431 orig_flags=
5c08dbbd
JH
432 while test $# -ne 0
433 do
434 case "$1" in
435 -q|--quiet)
2e6a30ef 436 GIT_QUIET=1
5c08dbbd 437 ;;
be4d2c83 438 -i|--init)
d92a3959 439 init=1
be4d2c83 440 ;;
31ca3ac3 441 -N|--no-fetch)
31ca3ac3
FF
442 nofetch=1
443 ;;
9db31bdf
NMC
444 -f|--force)
445 force=$1
446 ;;
ca2cedba 447 -r|--rebase)
32948425 448 update="rebase"
ca2cedba 449 ;;
d92a3959
MT
450 --reference)
451 case "$2" in '') usage ;; esac
452 reference="--reference=$2"
98dbe63d
KB
453 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
454 shift
d92a3959
MT
455 ;;
456 --reference=*)
457 reference="$1"
d92a3959 458 ;;
42b49178 459 -m|--merge)
42b49178
JH
460 update="merge"
461 ;;
b13fd5c1 462 --recursive)
b13fd5c1
JH
463 recursive=1
464 ;;
efc5fb6a
JH
465 --checkout)
466 update="checkout"
467 ;;
5c08dbbd
JH
468 --)
469 shift
470 break
471 ;;
472 -*)
473 usage
474 ;;
475 *)
476 break
477 ;;
478 esac
98dbe63d
KB
479 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
480 shift
5c08dbbd
JH
481 done
482
d92a3959
MT
483 if test -n "$init"
484 then
485 cmd_init "--" "$@" || return
486 fi
487
1b4735d9 488 cloned_modules=
15ffb7cd
FG
489 module_list "$@" | {
490 err=
70c7ac22
LH
491 while read mode sha1 stage path
492 do
313ee0d6
NMC
493 if test "$stage" = U
494 then
495 echo >&2 "Skipping unmerged submodule $path"
496 continue
497 fi
941987a5 498 name=$(module_name "$path") || exit
5be60078 499 url=$(git config submodule."$name".url)
efc5fb6a
JH
500 if ! test -z "$update"
501 then
502 update_module=$update
503 else
504 update_module=$(git config submodule."$name".update)
505 fi
506
507 if test "$update_module" = "none"
508 then
509 echo "Skipping submodule '$path'"
510 continue
511 fi
512
211b7f19 513 if test -z "$url"
70c7ac22
LH
514 then
515 # Only mention uninitialized submodules when its
516 # path have been specified
517 test "$#" != "0" &&
1c2ef66f
ÆAB
518 say "$(eval_gettext "Submodule path '\$path' not initialized
519Maybe you want to use 'update --init'?")"
211b7f19
LH
520 continue
521 fi
522
ba88a1fe 523 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19 524 then
d92a3959 525 module_clone "$path" "$url" "$reference"|| exit
1b4735d9 526 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
527 subsha1=
528 else
74ae1419 529 subsha1=$(clear_local_git_env; cd "$path" &&
5be60078 530 git rev-parse --verify HEAD) ||
497ee872 531 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
70c7ac22 532 fi
211b7f19 533
70c7ac22
LH
534 if test "$subsha1" != "$sha1"
535 then
9db31bdf
NMC
536 subforce=$force
537 # If we don't already have a -f flag and the submodule has never been checked out
538 if test -z "$subsha1" -a -z "$force"
b9b378a0 539 then
9db31bdf 540 subforce="-f"
b9b378a0 541 fi
31ca3ac3
FF
542
543 if test -z "$nofetch"
544 then
e5f522d6
JL
545 # Run fetch only if $sha1 isn't present or it
546 # is not reachable from a ref.
74ae1419 547 (clear_local_git_env; cd "$path" &&
f5799e05 548 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 549 test -z "$rev") || git-fetch)) ||
497ee872 550 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
31ca3ac3
FF
551 fi
552
1b4735d9
SO
553 # Is this something we just cloned?
554 case ";$cloned_modules;" in
555 *";$name;"*)
556 # then there is no local change to integrate
557 update_module= ;;
558 esac
559
877449c1 560 must_die_on_failure=
32948425
JH
561 case "$update_module" in
562 rebase)
563 command="git rebase"
ee653c89
ÆAB
564 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
565 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
877449c1 566 must_die_on_failure=yes
32948425 567 ;;
42b49178
JH
568 merge)
569 command="git merge"
ee653c89
ÆAB
570 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
571 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
877449c1 572 must_die_on_failure=yes
42b49178 573 ;;
32948425 574 *)
9db31bdf 575 command="git checkout $subforce -q"
ee653c89
ÆAB
576 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
577 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
32948425
JH
578 ;;
579 esac
70c7ac22 580
15ffb7cd
FG
581 if (clear_local_git_env; cd "$path" && $command "$sha1")
582 then
ff968f03 583 say "$say_msg"
877449c1
JH
584 elif test -n "$must_die_on_failure"
585 then
ff968f03 586 die_with_status 2 "$die_msg"
15ffb7cd 587 else
ff968f03 588 err="${err};$die_msg"
877449c1 589 continue
15ffb7cd 590 fi
70c7ac22 591 fi
b13fd5c1
JH
592
593 if test -n "$recursive"
594 then
15ffb7cd
FG
595 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
596 res=$?
597 if test $res -gt 0
598 then
ff968f03 599 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
15ffb7cd
FG
600 if test $res -eq 1
601 then
ff968f03 602 err="${err};$die_msg"
15ffb7cd
FG
603 continue
604 else
ff968f03 605 die_with_status $res "$die_msg"
15ffb7cd
FG
606 fi
607 fi
b13fd5c1 608 fi
70c7ac22 609 done
15ffb7cd
FG
610
611 if test -n "$err"
612 then
613 OIFS=$IFS
614 IFS=';'
615 for e in $err
616 do
617 if test -n "$e"
618 then
619 echo >&2 "$e"
620 fi
621 done
622 IFS=$OIFS
623 exit 1
624 fi
625 }
70c7ac22
LH
626}
627
bffe71f4
EM
628set_name_rev () {
629 revname=$( (
74ae1419 630 clear_local_git_env
bffe71f4 631 cd "$1" && {
5be60078
JH
632 git describe "$2" 2>/dev/null ||
633 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
634 git describe --contains "$2" 2>/dev/null ||
635 git describe --all --always "$2"
bffe71f4
EM
636 }
637 ) )
638 test -z "$revname" || revname=" ($revname)"
639}
28f9af5d
PY
640#
641# Show commit summary for submodules in index or working tree
642#
643# If '--cached' is given, show summary between index and given commit,
644# or between working tree and given commit
645#
646# $@ = [commit (default 'HEAD'),] requested paths (default all)
647#
648cmd_summary() {
f2dc06a3 649 summary_limit=-1
d0f64dd4 650 for_status=
1c244f6e 651 diff_cmd=diff-index
f2dc06a3 652
28f9af5d
PY
653 # parse $args after "submodule ... summary".
654 while test $# -ne 0
655 do
656 case "$1" in
657 --cached)
658 cached="$1"
659 ;;
1c244f6e
JL
660 --files)
661 files="$1"
662 ;;
d0f64dd4
PY
663 --for-status)
664 for_status="$1"
665 ;;
f2dc06a3
PY
666 -n|--summary-limit)
667 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
668 then
669 :
670 else
671 usage
672 fi
673 shift
674 ;;
28f9af5d
PY
675 --)
676 shift
677 break
678 ;;
679 -*)
680 usage
681 ;;
682 *)
683 break
684 ;;
685 esac
686 shift
687 done
bffe71f4 688
f2dc06a3
PY
689 test $summary_limit = 0 && return
690
3deea89c 691 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
692 then
693 head=$rev
caa9c3ca 694 test $# = 0 || shift
3deea89c
JH
695 elif test -z "$1" -o "$1" = "HEAD"
696 then
14e940d7
JH
697 # before the first commit: compare with an empty tree
698 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 699 test -z "$1" || shift
28f9af5d 700 else
3deea89c 701 head="HEAD"
28f9af5d
PY
702 fi
703
1c244f6e
JL
704 if [ -n "$files" ]
705 then
706 test -n "$cached" &&
b9b9c22f 707 die "$(gettext -- "--cached cannot be used with --files")"
1c244f6e
JL
708 diff_cmd=diff-files
709 head=
710 fi
711
28f9af5d
PY
712 cd_to_toplevel
713 # Get modified modules cared by user
18076502 714 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 715 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
716 while read mod_src mod_dst sha1_src sha1_dst status name
717 do
718 # Always show modules deleted or type-changed (blob<->module)
719 test $status = D -o $status = T && echo "$name" && continue
720 # Also show added or modified modules which are checked out
721 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
722 echo "$name"
723 done
724 )
1cb639e6 725
d0f64dd4
PY
726 test -z "$modules" && return
727
18076502 728 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 729 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
730 cut -c2- |
731 while read mod_src mod_dst sha1_src sha1_dst status name
732 do
733 if test -z "$cached" &&
734 test $sha1_dst = 0000000000000000000000000000000000000000
735 then
736 case "$mod_dst" in
737 160000)
738 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
739 ;;
740 100644 | 100755 | 120000)
741 sha1_dst=$(git hash-object $name)
742 ;;
743 000000)
744 ;; # removed
745 *)
746 # unexpected type
6ff875c5 747 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
748 continue ;;
749 esac
750 fi
751 missing_src=
752 missing_dst=
753
754 test $mod_src = 160000 &&
30353a40 755 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
756 missing_src=t
757
758 test $mod_dst = 160000 &&
30353a40 759 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 760 missing_dst=t
bffe71f4 761
1cb639e6
PY
762 total_commits=
763 case "$missing_src,$missing_dst" in
764 t,)
f62f8212 765 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
1cb639e6
PY
766 ;;
767 ,t)
f62f8212 768 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
769 ;;
770 t,t)
f62f8212 771 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
772 ;;
773 *)
774 errmsg=
775 total_commits=$(
776 if test $mod_src = 160000 -a $mod_dst = 160000
777 then
778 range="$sha1_src...$sha1_dst"
779 elif test $mod_src = 160000
780 then
781 range=$sha1_src
782 else
783 range=$sha1_dst
784 fi
785 GIT_DIR="$name/.git" \
b0e621ad 786 git rev-list --first-parent $range -- | wc -l
1cb639e6 787 )
eed35595 788 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
789 ;;
790 esac
791
792 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
793 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
794 if test $status = T
795 then
b3e73449
ÆAB
796 blob="$(gettext "blob")"
797 submodule="$(gettext "submodule")"
1cb639e6
PY
798 if test $mod_dst = 160000
799 then
b3e73449 800 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 801 else
b3e73449 802 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
803 fi
804 else
805 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
806 fi
807 if test -n "$errmsg"
808 then
809 # Don't give error msg for modification whose dst is not submodule
810 # i.e. deleted or changed to blob
811 test $mod_dst = 160000 && echo "$errmsg"
812 else
813 if test $mod_src = 160000 -a $mod_dst = 160000
814 then
f2dc06a3
PY
815 limit=
816 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 817 GIT_DIR="$name/.git" \
f2dc06a3 818 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
819 --first-parent $sha1_src...$sha1_dst
820 elif test $mod_dst = 160000
821 then
822 GIT_DIR="$name/.git" \
823 git log --pretty='format: > %s' -1 $sha1_dst
824 else
825 GIT_DIR="$name/.git" \
826 git log --pretty='format: < %s' -1 $sha1_src
827 fi
828 echo
829 fi
830 echo
d0f64dd4
PY
831 done |
832 if test -n "$for_status"; then
f17a5d34 833 if [ -n "$files" ]; then
6ff875c5 834 gettextln "# Submodules changed but not updated:"
f17a5d34 835 else
6ff875c5 836 gettextln "# Submodule changes to be committed:"
f17a5d34 837 fi
d0f64dd4
PY
838 echo "#"
839 sed -e 's|^|# |' -e 's|^# $|#|'
840 else
841 cat
842 fi
28f9af5d 843}
70c7ac22 844#
941987a5 845# List all submodules, prefixed with:
70c7ac22
LH
846# - submodule not initialized
847# + different revision checked out
848#
849# If --cached was specified the revision in the index will be printed
850# instead of the currently checked out revision.
851#
852# $@ = requested paths (default to all)
853#
23a485e3 854cmd_status()
70c7ac22 855{
5c08dbbd 856 # parse $args after "submodule ... status".
98dbe63d 857 orig_flags=
5c08dbbd
JH
858 while test $# -ne 0
859 do
860 case "$1" in
861 -q|--quiet)
2e6a30ef 862 GIT_QUIET=1
5c08dbbd
JH
863 ;;
864 --cached)
865 cached=1
866 ;;
64b19ffe
JH
867 --recursive)
868 recursive=1
869 ;;
5c08dbbd
JH
870 --)
871 shift
872 break
873 ;;
874 -*)
875 usage
876 ;;
877 *)
878 break
879 ;;
880 esac
98dbe63d 881 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
882 shift
883 done
884
a7b3269c 885 module_list "$@" |
70c7ac22
LH
886 while read mode sha1 stage path
887 do
941987a5 888 name=$(module_name "$path") || exit
5be60078 889 url=$(git config submodule."$name".url)
64b19ffe 890 displaypath="$prefix$path"
313ee0d6
NMC
891 if test "$stage" = U
892 then
893 say "U$sha1 $displaypath"
894 continue
895 fi
ba88a1fe 896 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22 897 then
64b19ffe 898 say "-$sha1 $displaypath"
70c7ac22
LH
899 continue;
900 fi
41c7c1bd 901 set_name_rev "$path" "$sha1"
18076502 902 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
70c7ac22 903 then
64b19ffe 904 say " $sha1 $displaypath$revname"
70c7ac22
LH
905 else
906 if test -z "$cached"
907 then
74ae1419 908 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 909 set_name_rev "$path" "$sha1"
70c7ac22 910 fi
64b19ffe
JH
911 say "+$sha1 $displaypath$revname"
912 fi
913
914 if test -n "$recursive"
915 then
916 (
917 prefix="$displaypath/"
74ae1419 918 clear_local_git_env
64b19ffe 919 cd "$path" &&
a7eff1a8 920 eval cmd_status "$orig_args"
64b19ffe 921 ) ||
497ee872 922 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
70c7ac22
LH
923 fi
924 done
925}
2327f61e
DA
926#
927# Sync remote urls for submodules
928# This makes the value for remote.$remote.url match the value
929# specified in .gitmodules.
930#
931cmd_sync()
932{
933 while test $# -ne 0
934 do
935 case "$1" in
936 -q|--quiet)
2e6a30ef 937 GIT_QUIET=1
2327f61e
DA
938 shift
939 ;;
940 --)
941 shift
942 break
943 ;;
944 -*)
945 usage
946 ;;
947 *)
948 break
949 ;;
950 esac
951 done
952 cd_to_toplevel
953 module_list "$@" |
954 while read mode sha1 stage path
955 do
956 name=$(module_name "$path")
957 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
958
959 # Possibly a url relative to parent
960 case "$url" in
961 ./*|../*)
962 url=$(resolve_relative_url "$url") || exit
963 ;;
964 esac
965
ccee6086 966 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 967 then
0591c0a5 968 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
ccee6086
JH
969 git config submodule."$name".url "$url"
970
971 if test -e "$path"/.git
972 then
973 (
974 clear_local_git_env
975 cd "$path"
976 remote=$(get_default_remote)
977 git config remote."$remote".url "$url"
978 )
979 fi
2327f61e
DA
980 fi
981 done
982}
70c7ac22 983
5c08dbbd
JH
984# This loop parses the command line arguments to find the
985# subcommand name to dispatch. Parsing of the subcommand specific
986# options are primarily done by the subcommand implementations.
987# Subcommand specific options such as --branch and --cached are
988# parsed here as well, for backward compatibility.
989
990while test $# != 0 && test -z "$command"
70c7ac22
LH
991do
992 case "$1" in
2327f61e 993 add | foreach | init | update | status | summary | sync)
5c08dbbd 994 command=$1
70c7ac22
LH
995 ;;
996 -q|--quiet)
2e6a30ef 997 GIT_QUIET=1
70c7ac22 998 ;;
ecda0723
SV
999 -b|--branch)
1000 case "$2" in
1001 '')
1002 usage
1003 ;;
1004 esac
1005 branch="$2"; shift
1006 ;;
70c7ac22 1007 --cached)
28f9af5d 1008 cached="$1"
70c7ac22
LH
1009 ;;
1010 --)
1011 break
1012 ;;
1013 -*)
1014 usage
1015 ;;
1016 *)
1017 break
1018 ;;
1019 esac
1020 shift
1021done
1022
5c08dbbd
JH
1023# No command word defaults to "status"
1024test -n "$command" || command=status
1025
1026# "-b branch" is accepted only by "add"
1027if test -n "$branch" && test "$command" != add
1028then
ecda0723 1029 usage
5c08dbbd
JH
1030fi
1031
28f9af5d
PY
1032# "--cached" is accepted only by "status" and "summary"
1033if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1034then
70c7ac22 1035 usage
5c08dbbd
JH
1036fi
1037
1038"cmd_$command" "$@"